#import "Account.h"

@implementation Account

-(void) setName: (NSString *) theName
{
	[accName autorelease];
	accName = [[NSString alloc] initWithString: theName];
}

-(void) setDeposit: (int) theDeposit
{
	accDeposit = theDeposit;
}

-(void) setName: (NSString *) theName andDeposit: (int) theDeposit
{
	accDeposit = theDeposit;
	[self setName: theName];
}

/*-(id) initWithName: (NSString *) theName andDeposit: (int) theDeposit
{
	self = [super init];
	[self setName: theName andDeposit: theDeposit];
	return self;
}*/


-(NSString *) accName
{
	return accName;
}

-(int) accDeposit
{
	return accDeposit;
}

-(void) print
{
	printf("Name: %s\nDeposit: %i\n", [accName cString], accDeposit);
}

-(Account *) copyWithZone: (NSZone *) zone
{
	Account *newAccount = [[Account allocWithZone: zone] init];
	[newAccount setName: accName andDeposit: accDeposit];
	return newAccount;
}

-(NSComparisonResult) compareNames: (id) element
{
	return [accName compare: [element accName]];
}

-(void) encodeWithCoder: (NSCoder *) encoder
{
	[encoder encodeObject: accName];
	[encoder encodeValueOfObjCType: @encode(int) at: &accDeposit];
}

-(id) initWithCoder: (NSCoder *) decoder
{
	accName = [[decoder decodeObject] retain];
	[decoder decodeValueOfObjCType: @encode(int) at: &accDeposit];
	return self;
}


-(void) dealloc {
	printf(" account deallocating...\n");
	[accName release];
	[super dealloc];
}

@end